Search.setIndex({"docnames": ["boyer_moore", "building", "config", "email", "filling", "geometry", "index", "intro", "json", "memory", "mmap", "pools", "projects", "promises", "ravenscar", "refcount", "scripting", "storage_pools", "strings", "templates", "terminals", "traces", "tribooleans", "vfs"], "filenames": ["boyer_moore.rst", "building.rst", "config.rst", "email.rst", "filling.rst", "geometry.rst", "index.rst", "intro.rst", "json.rst", "memory.rst", "mmap.rst", "pools.rst", "projects.rst", "promises.rst", "ravenscar.rst", "refcount.rst", "scripting.rst", "storage_pools.rst", "strings.rst", "templates.rst", "terminals.rst", "traces.rst", "tribooleans.rst", "vfs.rst"], "titles": ["<span class=\"section-number\">8. </span><strong>Boyer-Moore</strong>: Searching strings", "<span class=\"section-number\">2. </span>Building GNATColl", "<span class=\"section-number\">19. </span><strong>Config</strong>: Parsing configuration files", "<span class=\"section-number\">11. </span><strong>Email</strong>: Processing email messages", "<span class=\"section-number\">9. </span><strong>Paragraph filling</strong>: formatting text", "<span class=\"section-number\">16. </span><strong>Geometry</strong>: primitive geometric operations", "GNATColl Core Components", "<span class=\"section-number\">1. </span>Introduction to the GNAT Component Collection", "<span class=\"section-number\">21. </span><strong>JSON</strong>: handling JSON data", "<span class=\"section-number\">6. </span><strong>Memory</strong>: Monitoring memory usage", "<span class=\"section-number\">7. </span><strong>Mmap</strong>: Reading and Writing Files", "<span class=\"section-number\">20. </span><strong>Pools</strong>: Controlling access to resources", "<span class=\"section-number\">17. </span><strong>Projects</strong>: manipulating gpr files", "<span class=\"section-number\">23. </span><strong>Promises</strong>: deferring work", "<span class=\"section-number\">12. </span><strong>Ravenscar</strong>: patterns for multitasking", "<span class=\"section-number\">18. </span><strong>Refcount</strong>: Reference counting", "<span class=\"section-number\">3. </span><strong>Scripts</strong>: Embedding script languages", "<span class=\"section-number\">13. </span><strong>Storage Pools</strong>: controlling memory management", "<span class=\"section-number\">5. </span><strong>Strings</strong>: high-performance strings", "<span class=\"section-number\">10. </span><strong>Templates</strong>: generating text", "<span class=\"section-number\">22. </span><strong>Terminal</strong>: controlling the console", "<span class=\"section-number\">4. </span><strong>Traces</strong>: Logging information", "<span class=\"section-number\">15. </span><strong>Tribooleans</strong>: Three state logic", "<span class=\"section-number\">14. </span><strong>VFS</strong>: Manipulating Files"], "terms": {"although": [0, 10, 12, 15, 16, 18, 21, 23], "ada": [0, 3, 7, 8, 9, 10, 12, 14, 15, 16, 17, 18, 19, 20, 21, 23], "standard": [0, 8, 9, 17, 18, 20, 21, 23], "provid": [0, 1, 2, 3, 4, 5, 6, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23], "number": [0, 4, 5, 8, 9, 10, 11, 15, 16, 17, 18, 19, 21], "subprogram": [0, 3, 9, 10, 12, 16, 17, 18, 19, 20, 21, 23], "most": [0, 3, 8, 9, 10, 14, 15, 16, 17, 18, 20, 21, 23], "notabl": [0, 10], "fix": 0, "unbound": [0, 18], "bound": [0, 10, 16], "packag": [0, 1, 3, 4, 5, 6, 7, 8, 9, 10, 11, 13, 14, 15, 16, 17, 18, 20, 21, 22, 23], "through": [0, 1, 2, 3, 9, 11, 14, 15, 16, 17, 21, 22, 23], "index": [0, 6, 12, 18], "function": [0, 1, 8, 9, 10, 13, 20, 21, 22, 23], "do": [0, 2, 9, 10, 11, 12, 13, 15, 16, 17, 18, 20, 21, 22, 23], "gener": [0, 1, 2, 3, 5, 6, 7, 9, 11, 13, 14, 15, 16, 17, 18, 20, 21, 23], "effici": [0, 3, 10, 11, 15, 17, 18, 23], "algorithm": [0, 4, 21], "The": [0, 1, 2, 3, 4, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 18, 19, 20, 21, 23], "gnatcol": [0, 2, 3, 4, 5, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 20, 21, 22, 23], "boyer_moor": 0, "one": [0, 2, 3, 7, 8, 9, 11, 15, 16, 17, 18, 21, 23], "optim": [0, 6, 9, 10, 17], "exist": [0, 3, 10, 12, 15, 16, 21, 23], "sever": [0, 4, 7, 10, 12, 15, 16, 17, 18, 21, 23], "other": [0, 2, 3, 8, 9, 10, 12, 14, 15, 16, 17, 18, 19, 21, 23], "which": [0, 1, 2, 3, 4, 8, 9, 10, 11, 16, 17, 18, 19, 21, 23], "might": [0, 2, 3, 15, 16, 18, 21, 23], "more": [0, 3, 4, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 20, 21, 22, 23], "depend": [0, 8, 10, 16, 18, 20, 21, 23], "pattern": [0, 6, 9, 15, 16, 21], "It": [0, 1, 3, 8, 10, 16, 18, 19, 20, 21, 23], "deal": [0, 7, 16, 23], "doe": [0, 1, 3, 9, 10, 12, 16, 21, 23], "handl": [0, 5, 6, 7, 10, 11, 13, 16, 18, 20, 23], "regular": [0, 14], "express": 0, "instanc": [0, 1, 3, 9, 11, 13, 14, 17, 18, 19, 21, 23], "thi": [0, 1, 2, 3, 5, 6, 8, 9, 10, 11, 12, 13, 15, 16, 17, 18, 19, 20, 21, 23], "need": [0, 2, 3, 8, 9, 10, 11, 13, 15, 16, 17, 18, 21, 23], "preprocess": 0, "its": [0, 3, 8, 10, 15, 16, 18, 20, 21, 23], "kei": [0, 2, 18], "perform": [0, 6, 10, 16, 23], "ani": [0, 1, 2, 3, 6, 8, 9, 12, 16, 18, 19, 21, 22, 23], "specif": [0, 1, 2, 9, 10, 12, 16, 18, 19, 21, 23], "analysi": [0, 14], "Its": [0, 9, 21], "execut": [0, 6, 9, 13, 14, 21], "time": [0, 1, 2, 3, 9, 10, 11, 13, 14, 15, 16, 17, 18, 19, 21, 23], "can": [0, 1, 2, 3, 5, 8, 9, 10, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23], "sub": [0, 14], "linear": 0, "doesn": [0, 8, 16, 18, 21], "t": [0, 2, 8, 16, 18, 21, 23], "actual": [0, 2, 3, 9, 10, 13, 16, 18, 19, 21, 23], "check": [0, 6, 12, 16, 18, 23], "everi": [0, 15, 16, 21], "charact": [0, 3, 6, 10, 16, 19, 21], "skip": 0, "over": [0, 2, 10, 16, 17], "some": [0, 3, 4, 5, 9, 10, 12, 13, 15, 16, 18, 20, 21, 22, 23], "them": [0, 2, 3, 4, 6, 10, 11, 16, 21, 23], "worst": 0, "case": [0, 2, 3, 10, 16, 17, 18, 19, 21, 22, 23], "ha": [0, 1, 3, 8, 9, 11, 15, 16, 17, 18, 21, 23], "been": [0, 3, 9, 16, 17, 21], "prove": [0, 18], "approxim": 0, "3": [0, 5, 8, 12, 16, 19], "n": 0, "comparison": 0, "henc": 0, "complex": [0, 3, 8, 13, 16, 18, 19, 21], "o": [0, 16, 19], "longer": [0, 3, 11, 15, 19, 23], "faster": [0, 10, 11, 18], "sinc": [0, 2, 3, 9, 10, 11, 15, 16, 18, 21, 23], "context": [0, 8, 16, 17, 18, 19, 21, 23], "how": [0, 9, 10, 11, 12, 14, 16, 17, 21], "mani": [0, 9, 16, 17], "when": [0, 2, 3, 9, 10, 11, 15, 16, 17, 18, 19, 20, 21, 22, 23], "non": [0, 19], "match": [0, 3, 9, 16, 19], "i": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19, 20, 22, 23], "found": [0, 2, 3, 4, 16, 18, 19, 21, 23], "we": [0, 2, 3, 8, 9, 10, 12, 13, 15, 16, 18, 21, 22, 23], "go": [0, 2, 9, 10, 16], "detail": [0, 1, 2, 4, 10, 12, 16, 18, 21], "descript": [0, 11, 16], "follow": [0, 1, 7, 9, 10, 12, 15, 16, 17, 18, 19, 21], "being": [0, 16], "comput": [0, 5, 14, 16, 23], "an": [0, 2, 3, 4, 8, 9, 10, 12, 13, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23], "incorrect": 0, "point": [0, 2, 5, 8, 9, 15, 16, 18, 21, 23], "wa": [0, 1, 3, 4, 10, 15, 16, 18, 19, 21, 23], "read": [0, 2, 6, 8, 13, 16, 18, 21, 23], "In": [0, 1, 2, 3, 5, 10, 15, 16, 17, 18, 20, 21, 23], "addit": [0, 10, 15, 16, 18, 21, 23], "tri": [0, 3, 16, 18], "start": [0, 2, 3, 10, 16, 18, 19, 21, 23], "from": [0, 1, 2, 3, 8, 9, 10, 12, 13, 15, 16, 18, 21, 23], "end": [0, 2, 3, 5, 7, 8, 9, 10, 11, 12, 15, 16, 18, 20, 21, 23], "greater": 0, "For": [0, 1, 3, 9, 13, 15, 16, 17, 18, 19, 21, 23], "you": [0, 1, 2, 3, 5, 9, 10, 12, 13, 15, 16, 17, 18, 19, 20, 21, 23], "ar": [0, 1, 2, 3, 6, 7, 8, 9, 10, 11, 13, 14, 15, 16, 18, 19, 20, 21, 22, 23], "look": [0, 3, 4, 10, 16, 19, 21], "abc": 0, "abdefg": 0, "first": [0, 1, 2, 3, 9, 10, 12, 15, 16, 18, 19, 21], "posit": [0, 18, 19], "compar": [0, 9, 10], "c": [0, 2, 9, 10, 16, 18, 21, 23], "d": [0, 21, 23], "appear": [0, 16], "know": [0, 8, 9, 13, 15, 16, 18, 21, 23], "immedi": [0, 10, 13, 19], "after": [0, 16, 18, 19, 21], "us": [0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 12, 14, 15, 16, 17, 18, 19, 20, 22, 23], "extrem": [0, 16], "easi": [0, 8, 9, 18, 23], "onli": [0, 1, 2, 3, 9, 10, 11, 14, 15, 16, 17, 18, 21, 22], "limit": [0, 3, 9, 16, 17, 18, 20, 21], "api": [0, 2, 6, 10, 15, 23], "declar": [0, 2, 3, 5, 8, 10, 12, 15, 16, 17, 18, 21], "str": [0, 10, 21], "constant": [0, 2, 5, 10, 12, 15, 16, 21], "abdeabcfgabc": 0, "integ": [0, 2, 8, 10, 16], "begin": [0, 2, 3, 5, 8, 9, 10, 12, 15, 16, 18, 20, 21, 23], "compil": [0, 1, 2, 7, 9, 16, 17, 18, 21], "either": [0, 3, 8, 9, 15, 16, 18, 20, 21, 23], "return": [0, 3, 9, 11, 13, 14, 15, 16, 17, 19, 21, 23], "1": [0, 5, 6, 8, 10, 12, 16, 18, 19, 20, 21, 23], "did": [0, 18, 21], "exampl": [0, 2, 3, 6, 9, 10, 12, 14, 15, 16, 17, 18, 19, 20, 21, 22, 23], "abov": [0, 2, 8, 9, 10, 15, 16, 18, 19, 21, 23], "5": [0, 5, 16, 18], "If": [0, 1, 9, 10, 12, 16, 17, 18, 19, 21], "want": [0, 2, 3, 9, 10, 12, 13, 15, 16, 17, 18, 19, 21, 23], "find": [0, 2, 9, 17, 18, 21], "next": [0, 2, 3, 11, 16, 17, 18, 19, 21], "have": [0, 1, 2, 3, 9, 10, 13, 15, 16, 17, 18, 21, 22, 23], "pass": [0, 3, 10, 16, 18, 19], "substr": [0, 6, 19], "6": [0, 5, 21], "last": [0, 10, 16, 18, 21], "instruct": [1, 16], "below": [1, 8, 9, 16, 18, 21, 23], "assum": [1, 2, 16, 21, 23], "unpack": 1, "temporari": [1, 21], "directori": [1, 2, 16, 21, 23], "installdir": 1, "would": [1, 2, 10, 15, 16, 18, 21], "like": [1, 5, 8, 9, 10, 13, 15, 16, 17, 18, 19, 23], "select": [1, 16], "compon": [1, 3, 16], "further": [1, 2, 8, 13, 16, 19], "recent": 1, "gnat": [1, 6, 9, 10, 12, 14, 17, 18, 21, 23], "well": [1, 3, 11, 16, 18, 20, 21, 23], "gprbuild": 1, "step": [1, 9, 12, 16], "done": [1, 2, 3, 9, 10, 16, 17, 18, 19, 21, 23], "run": [1, 2, 10, 14, 16, 17, 19, 23], "make": [1, 9, 10, 15, 16, 18, 19, 21, 23], "setup": [1, 16, 23], "command": [1, 9, 16, 19, 23], "root": [1, 12, 23], "tree": [1, 8, 12], "option": [1, 2, 3, 16, 18, 21, 22], "satisfi": [1, 17], "default": [1, 2, 9, 16, 18, 19, 20, 21], "valu": [1, 2, 8, 10, 12, 13, 16, 18, 19, 20, 21, 22], "On": [1, 8, 10, 16, 20, 23], "window": [1, 2, 9, 16, 20, 21, 23], "requir": [1, 9, 10, 16, 18, 21], "properli": [1, 13, 16, 17], "unix": [1, 10, 20, 21, 23], "tool": [1, 19], "variabl": [1, 2, 9, 11, 16, 21], "process": [1, 6, 7, 8, 9, 13, 16, 19, 20, 21], "prefix": [1, 2, 3, 8, 16], "locat": [1, 2, 16, 17, 21, 23], "integr": [1, 14, 16, 18], "treat": [1, 23], "ye": [1, 16, 21], "so": [1, 2, 3, 5, 8, 9, 10, 11, 13, 15, 16, 18, 20, 21, 23], "project": [1, 6, 9], "later": [1, 3, 16, 17, 21, 23], "referenc": [1, 15], "predefin": [1, 7, 16, 21], "add": [1, 2, 3, 9, 16, 21], "normal": 1, "target": 1, "subdir": [1, 9], "control": [1, 3, 6, 15, 16, 18, 23], "prod": 1, "debug": [1, 6, 9, 21], "processor": 1, "parallel": [1, 23], "0": [1, 5, 8, 9, 10, 15, 16, 18, 20], "all": [1, 2, 3, 6, 7, 8, 9, 12, 15, 17, 18, 19, 21, 22, 23], "avail": [1, 7, 8, 9, 13, 15, 16, 18, 21, 23], "core": [1, 14, 16], "cross": [1, 2, 20], "auto": [1, 20], "detect": [1, 2, 9], "nativ": [1, 23], "platform": [1, 20, 21], "source_dir": [1, 9], "out": [1, 2, 3, 9, 15, 16, 21], "enable_shar": 1, "whether": [1, 6, 16, 17, 18, 20, 23], "share": [1, 14, 16, 18, 21], "static": [1, 2, 16], "pic": 1, "librari": [1, 3, 7, 8, 16, 21, 23], "variant": 1, "should": [1, 3, 7, 9, 10, 11, 12, 13, 15, 16, 17, 18, 19, 21, 23], "built": [1, 16], "intend": [1, 2, 10, 11, 16], "specifi": [1, 2, 3, 5, 9, 15, 16, 17, 19, 21, 22], "modul": [1, 3, 6, 9, 19], "gnatcoll_mmap": 1, "mmap": [1, 6], "support": [1, 2, 3, 6, 10, 20, 21, 22, 23], "effect": [1, 9, 16, 21], "where": [1, 2, 3, 9, 10, 11, 15, 16, 18, 19, 21, 22], "embed": [1, 6], "implement": [1, 2, 9, 11, 14, 15, 16, 18, 23], "alwai": [1, 10, 15, 16, 18, 19, 21, 23], "gnatcoll_madvis": 1, "madvis": 1, "unavail": 1, "gpr": [1, 6, 9], "file": [1, 3, 6, 7, 8, 9, 16, 18, 19, 20, 21], "simpl": [1, 3, 13, 16, 21], "though": 1, "version": [1, 9, 16, 19, 21], "relocat": 1, "simpler": [1, 10, 16, 20], "makefil": 1, "note": [1, 16, 18, 21, 23], "try": [1, 9, 16, 18, 20, 21, 23], "recompil": [1, 9, 16], "must": [1, 3, 12, 16, 17, 18, 21, 22, 23], "were": [1, 9, 16, 21, 23], "your": [1, 2, 3, 9, 10, 11, 15, 16, 17, 18, 19, 21, 23], "applic": [1, 2, 3, 6, 7, 9, 10, 11, 13, 14, 15, 17, 18, 20, 21, 23], "now": [1, 8, 16, 21], "code": [1, 2, 3, 7, 9, 10, 15, 16, 17, 18, 19, 21, 23], "ad": [1, 3, 8, 11, 13, 16, 18, 19, 21, 23], "claus": [1, 9, 18], "wish": [1, 5, 16, 23], "differ": [1, 2, 4, 10, 14, 16, 18, 23], "than": [1, 9, 10, 14, 16, 17, 18, 23], "overrid": [1, 2, 16, 20, 21, 22], "line": [1, 2, 4, 5, 9, 16, 18, 19, 20, 21], "altern": [1, 3, 9], "framework": [2, 16, 23], "manipul": [2, 3, 6, 10, 16, 18, 20], "These": [2, 3, 8, 9, 10, 15, 16, 21, 23], "prefer": [2, 16], "user": [2, 3, 6, 7, 13, 15, 16, 17, 18, 19, 20, 21, 22, 23], "chang": [2, 10, 16, 17, 18, 21], "interact": [2, 6, 7], "howev": [2, 3, 9, 10, 11, 15, 16, 17, 18, 21, 23], "possibl": [2, 3, 8, 9, 16, 18, 19, 21, 23], "both": [2, 8, 9, 14, 16, 18, 21, 23], "There": [2, 3, 10, 15, 16, 17, 18, 21, 22, 23], "lot": [2, 10, 16, 17, 18, 21, 23], "format": [2, 6, 8, 9, 21], "could": [2, 3, 10, 13, 15, 16, 18, 19, 21, 23], "chose": [2, 9, 16, 18, 23], "xml": [2, 8, 16], "hard": [2, 16, 23], "edit": [2, 3, 12], "manual": [2, 9, 15], "binari": [2, 3], "One": [2, 16, 18, 19, 21, 22, 23], "veri": [2, 15, 16, 18, 23], "often": [2, 3, 8, 9, 15, 16, 18, 20, 23], "ini": 2, "independ": [2, 3, 16, 23], "own": [2, 3, 9, 16, 18, 21, 23], "parser": [2, 3, 19], "compat": [2, 12, 16], "box": [2, 3], "let": [2, 13, 14, 15, 16, 18, 21, 23], "": [2, 3, 9, 10, 16, 17, 18, 21, 23], "simpli": [2, 16, 18, 21], "A": [2, 11, 13, 16, 18, 19, 20, 21, 23], "singl": [2, 3, 16, 17, 19, 21, 23], "comment": [2, 3, 4, 21], "section1": 2, "key1": 2, "key2": 2, "value2": 2, "section2": 2, "value3": 2, "sign": [2, 21], "pair": 2, "organ": [2, 16, 21], "section": [2, 3, 16, 21], "befor": [2, 3, 8, 10, 16, 17, 21], "consid": [2, 16], "part": [2, 3, 6, 7, 9, 10, 16, 19, 21, 23], "extend": [2, 3, 15, 16, 18, 22], "until": [2, 16, 18, 19], "associ": [2, 15, 16, 21, 22, 23], "variou": [2, 3, 9, 10, 16, 17, 18, 21, 22, 23], "string": [2, 3, 6, 7, 8, 10, 12, 16, 19, 21, 23], "boolean": [2, 8, 16, 22], "space": [2, 16, 17, 18], "left": 2, "right": [2, 15, 16], "trim": [2, 18], "therefor": [2, 3, 10, 15, 16, 18, 21], "irrelev": [2, 16], "interpret": [2, 16], "name": [2, 3, 6, 8, 9, 15, 18, 19, 20, 21], "rel": [2, 3, 16, 18, 21], "also": [2, 3, 7, 8, 9, 10, 16, 17, 18, 21, 23], "abstract": [2, 6, 10, 16], "iter": [2, 3, 8], "stream": [2, 3, 6, 16], "conceptu": 2, "memori": [2, 3, 6, 7, 8, 10, 15, 16, 18, 21, 23], "socket": [2, 3, 13, 21], "base": [2, 4, 7, 9, 16, 20, 21, 23], "special": [2, 16, 19, 21, 23], "loop": [2, 3, 10, 12, 18, 19, 20], "similar": [2, 8, 9, 15, 16, 18, 21, 23], "ini_pars": 2, "open": [2, 3, 10, 21], "set": [2, 3, 8, 14, 15, 16, 18, 19, 20, 21, 22, 23], "txt": [2, 16], "while": [2, 3, 10, 13, 15, 18], "at_end": 2, "put_lin": [2, 5, 8, 12, 16, 20], "made": [2, 3, 15, 16, 18, 21], "slightli": [2, 15, 18, 21], "lighter": [2, 8], "ada05": 2, "dot": [2, 8], "notat": [2, 8, 12, 19], "store": [2, 3, 9, 10, 15, 16, 17, 18, 21], "type": [2, 3, 5, 6, 8, 9, 10, 11, 15, 17, 22, 23], "But": [2, 9, 10, 15, 16, 18, 20], "easier": [2, 15, 16, 23], "interfac": [2, 7, 12, 13, 16, 20, 21, 23], "form": [2, 3, 6, 14, 16, 21], "config_pool": 2, "Such": [2, 16, 18, 23], "pool": [2, 6, 9], "fill": [2, 6, 8, 23], "each": [2, 3, 8, 9, 16, 18, 19, 21], "dure": [2, 20, 21], "lifetim": [2, 16], "explicit": [2, 8], "global": [2, 11, 16], "get": [2, 3, 8, 9, 15, 16, 18, 21, 22], "again": [2, 3, 11, 18], "third": [2, 16, 21], "layer": [2, 6], "solv": [2, 15, 16], "issu": [2, 7, 10, 15, 18], "typo": 2, "writ": 2, "That": [2, 10, 16, 17, 21], "anoth": [2, 8, 16, 18, 21, 23], "decid": [2, 9, 16, 17, 18], "renam": [2, 9], "place": [2, 8, 9, 17, 21], "refer": [2, 6, 8, 11, 16, 17, 18, 21, 23], "insid": [2, 5], "To": [2, 8, 9, 10, 15, 16, 21, 22, 23], "repres": [2, 3, 12, 16, 18, 21, 23], "access": [2, 3, 6, 9, 10, 15, 16, 17, 18, 21, 23], "two": [2, 3, 10, 15, 16, 18, 21, 23], "problem": [2, 10, 16, 21, 23], "section_key1": 2, "config_kei": 2, "creat": [2, 6, 8, 9, 11, 12, 15, 21, 23], "section_key2": 2, "natur": [2, 8, 18, 21], "syntax": [2, 8, 16, 21], "manag": [3, 6, 7, 8, 15, 16, 23], "extract": 3, "contain": [3, 8, 9, 10, 11, 12, 15, 16, 18, 19, 21, 23], "previous": 3, "new": [3, 5, 10, 15, 16, 17, 21, 23], "scratch": [3, 8], "fulli": [3, 12, 16, 18, 21], "mime": 3, "encod": [3, 6, 8, 18], "attach": 3, "current": [3, 9, 10, 16, 18, 21], "wai": [3, 10, 13, 16, 18, 22, 23], "send": [3, 7], "smtp": 3, "protocol": [3, 23], "rather": [3, 9, 16, 18], "represent": [3, 18], "convert": [3, 18, 21, 23], "see": [3, 11, 13, 14, 16, 18, 21, 22, 23], "aw": [3, 19], "necessari": [3, 16], "connect": [3, 11, 23], "server": [3, 6, 8, 11, 19], "mail": 3, "defin": [3, 6, 9, 10, 15, 16, 23], "numer": [3, 16], "rfc": 3, "document": [3, 4, 6, 13, 16, 18, 21, 23], "conform": 3, "best": [3, 12, 16], "basic": [3, 9, 10, 16, 18, 20], "header": [3, 17, 21], "field": [3, 8, 11, 16, 21], "indic": [3, 16, 19, 20, 21, 23], "who": 3, "sent": [3, 16, 20, 21], "whom": 3, "payload": 3, "aka": 3, "bodi": [3, 9, 21], "content": [3, 9, 10, 12, 15, 16, 18, 21], "text": [3, 6, 7, 16], "html": 3, "imag": 3, "transfer": [3, 16], "byte": [3, 10, 16, 17, 18, 23], "7": [3, 5, 18], "bit": [3, 9, 10, 18, 21], "thei": [3, 8, 9, 11, 14, 15, 16, 18, 21, 23], "decod": [3, 8], "origin": 3, "give": [3, 10, 16, 17, 18, 21], "seen": [3, 16, 23], "util": [3, 18, 21], "rest": [3, 16, 18, 21], "piec": 3, "inform": [3, 6, 9, 12, 16, 17, 23], "about": [3, 8, 10, 18, 23], "semant": [3, 14, 15, 16], "free": [3, 9, 10, 11, 15, 16, 18, 23], "x": 3, "those": [3, 9, 10, 12, 16, 18, 21, 22, 23], "address": [3, 9, 17, 18, 21], "TO": 3, "cc": 3, "among": [3, 18, 21, 23], "list": [3, 9, 12, 16, 18, 21, 23], "recipi": 3, "usual": [3, 9, 10, 16, 17, 22], "quit": 3, "becaus": [3, 8, 9, 16, 17, 18, 21], "full": [3, 11, 16, 17, 20, 23], "along": [3, 21], "date": [3, 11, 21], "precis": [3, 21], "contrari": [3, 16], "subject": 3, "brief": [3, 16], "overview": [3, 6, 16], "complic": 3, "come": [3, 16, 18, 23], "fact": [3, 10, 15, 16, 18, 21, 23], "ascii": [3, 18, 23], "subset": 3, "charset": 3, "initi": [3, 6, 9, 18, 21], "oper": [3, 6, 8, 14, 16, 18, 20, 21, 22, 23], "cours": [3, 10, 16, 17, 18, 21, 22, 23], "mean": [3, 6, 8, 15, 16, 17, 18, 21, 23], "freed": [3, 9, 11, 15], "automat": [3, 8, 9, 10, 11, 14, 15, 18, 20, 21, 23], "costli": [3, 15, 21], "big": [3, 10, 16, 18], "few": [3, 10, 16, 18, 20, 23], "concern": 3, "why": 3, "multipl": [3, 10, 13, 14, 16, 18], "ignor": [3, 21], "thu": [3, 14, 15, 16, 17, 18, 21], "onc": [3, 10, 11, 16, 21, 23], "directli": [3, 10, 20], "duplic": 3, "here": [3, 8, 10, 12, 15, 16, 18, 20, 21, 23], "unless": [3, 10, 16, 21], "write": [3, 6, 8, 9, 16, 19, 21, 23], "filter": [3, 19], "incom": 3, "instead": [3, 10, 11, 15, 16, 17, 18, 21], "what": [3, 10, 11, 16, 18, 21, 23], "call": [3, 8, 9, 10, 13, 14, 15, 16, 17, 18, 19, 20, 21, 23], "latter": [3, 14, 15, 18, 19, 21], "thousand": 3, "tradition": 3, "At": [3, 10, 15, 16, 23], "stage": [3, 16], "mbox": 3, "concaten": [3, 16, 19, 21], "separ": [3, 10, 16, 21, 23], "newlin": [3, 16, 21], "tag": [3, 8, 15, 16, 21, 23], "easili": [3, 13, 16, 21], "small": [3, 6, 9, 10, 17], "disk": [3, 10, 16, 21, 23], "cur": 3, "cursor": [3, 6], "msg": [3, 21], "filenam": 3, "my_mbox": 3, "mbox_cursor": 3, "has_el": 3, "get_messag": 3, "null_messag": 3, "As": [3, 9, 10, 11, 13, 15, 16, 18, 19, 21, 23], "Then": [3, 21], "ada2005": 3, "scheme": [3, 13, 18], "test": [3, 16, 21], "recommend": [3, 9, 10, 15, 16, 19, 21], "null": [3, 8, 15, 16, 21], "corrupt": 3, "still": [3, 9, 10, 15, 16, 18, 21], "chanc": [3, 16, 23], "readabl": [3, 19, 21, 23], "alreadi": [3, 12, 16, 17, 18, 21], "alter": [3, 6], "repli": 3, "reply_to": 3, "preset": 3, "thread": [3, 13, 16, 18, 21], "preserv": [3, 23], "mailer": 3, "paragraph_fil": 4, "take": [4, 10, 13, 15, 16, 18, 21, 23], "up": [4, 10, 11, 16, 17, 18, 21], "minim": [4, 16], "better": [4, 16, 18, 20, 21], "knuth_fil": 4, "invent": 4, "donald": 4, "knuth": 4, "tex": 4, "pretty_fil": 4, "judg": 4, "produc": 4, "aesthet": 4, "pleas": [4, 7, 8, 16, 18], "output": [4, 9, 12, 16, 18, 20, 21], "mai": [4, 6], "spec": [4, 12, 18, 22], "includ": [5, 6, 7, 9, 15, 16, 18, 23], "figur": 5, "segment": 5, "circl": 5, "rectangl": 5, "polygon": 5, "particular": [5, 10, 15, 16, 17, 18, 21], "intersect": 5, "distanc": 5, "coordin": 5, "float_geometri": 5, "float": [5, 8], "p1": 5, "p2": 5, "2": [5, 6, 12, 16, 18, 19, 21], "img": [5, 20], "Will": 5, "print": [5, 10, 12, 16, 21], "23607": 5, "Or": [5, 16], "involv": 5, "p3": 5, "p": 5, "4": [5, 10, 12, 18, 19], "9": [5, 16], "area": [5, 16, 23], "015": 5, "true": [5, 8, 12, 15, 16, 20, 22], "introduct": 6, "collect": [6, 17], "bug": 6, "report": [6, 16], "build": [6, 9, 12, 13, 16, 18], "configur": [6, 9, 16], "environ": [6, 7, 9, 16, 21, 23], "instal": [6, 16, 21], "script": 6, "languag": [6, 9, 17, 18, 23], "shell": [6, 21], "class": [6, 21], "export": 6, "consol": 6, "method": [6, 15], "startup": [6, 11], "multithread": 6, "trace": [6, 9, 16, 18], "log": [6, 16, 18], "unexpect": 6, "except": [6, 9, 15, 16, 19], "activ": [6, 9, 16], "decor": 6, "custom": 6, "syslog": 6, "dynam": [6, 16], "disabl": [6, 9, 16], "featur": [6, 8, 16, 19, 20], "high": [6, 10, 14], "size": [6, 9, 10, 16], "task": [6, 11, 15, 16], "safeti": [6, 15], "copi": [6, 23], "growth": 6, "strategi": [6, 17], "monitor": [6, 21], "usag": [6, 15, 18], "boyer": 6, "moor": 6, "search": [6, 21, 22], "paragraph": 6, "templat": [6, 9], "email": 6, "messag": [6, 16, 18, 21], "pars": [6, 8, 12, 18, 19, 21], "mailbox": 6, "ravenscar": 6, "multitask": [6, 16], "timer": 6, "storag": 6, "vf": [6, 12], "filesystem": 6, "remot": [6, 11], "factori": [6, 16, 21], "transport": 6, "virtual": [6, 16], "triboolean": 6, "three": [6, 10, 21, 23], "state": 6, "logic": 6, "geometri": 6, "primit": [6, 8, 16, 18, 21, 23], "geometr": 6, "refcount": [6, 11, 18], "count": [6, 9, 11, 18, 21, 23], "config": [6, 21], "resourc": [6, 14], "json": 6, "data": [6, 9, 10, 13, 15, 16, 17, 18, 22, 23], "termin": [6, 16], "color": [6, 16, 21], "promis": 6, "defer": 6, "work": [6, 10, 16, 18, 21, 23], "whole": [6, 10, 16, 18, 21], "clearli": 6, "mark": [6, 9], "copyright": 6, "notic": [6, 21], "unmodifi": [6, 19], "reusabl": 7, "known": [7, 16], "main": [7, 9, 13, 16], "principl": 7, "purpos": [7, 10, 16], "technologi": 7, "front": 7, "program": [7, 8, 9, 12, 14, 16, 18, 21], "studio": 7, "gp": [7, 16, 23], "develop": [7, 14, 16, 20, 21, 23], "tracker": 7, "web": [7, 8, 19], "serv": 7, "sourc": [7, 8, 9, 12, 16, 18, 21], "complement": 7, "rang": [7, 12], "common": [7, 14, 15, 16], "especi": [7, 10, 16], "enterpris": 7, "question": 7, "adacor": 7, "com": 7, "same": [7, 14, 15, 16, 17, 18, 19, 21, 23], "procedur": [7, 8, 9, 12, 16, 20, 21], "submit": 7, "toolset": 7, "itself": [7, 11, 12, 13, 14, 15, 16, 17, 18, 19, 21, 23], "commun": [8, 14, 21, 23], "between": [8, 13, 15, 16, 18, 23], "browser": 8, "plai": 8, "role": [8, 16], "much": [8, 10, 12, 16, 18, 20], "hand": 8, "advanc": [8, 16, 17, 19, 20, 22, 23], "valid": [8, 9, 10, 15, 17, 18, 21], "back": [8, 10, 14, 16, 20], "allow": [8, 16, 17, 21], "modifi": [8, 10, 16, 18], "entri": [8, 9, 19], "json_valu": 8, "json_null_typ": 8, "equival": 8, "json_boolean_typ": 8, "fals": [8, 20, 21, 22], "json_int_typ": 8, "long_long_integ": 8, "json_float_typ": 8, "long_float": 8, "utf": [8, 18, 23], "8": [8, 18, 23], "json_string_typ": 8, "arrai": [8, 18], "json_array_typ": 8, "object": [8, 15, 16, 21], "json_object_typ": 8, "sequenc": [8, 18, 20], "uniqu": 8, "map": [8, 10, 15, 16], "determinist": 8, "underneath": [8, 10], "foo": [8, 16, 21, 23], "json_str": 8, "inspect": 8, "modif": [8, 10, 16], "float_numb": 8, "mere": 8, "some_arrai": 8, "synthet": 8, "append": [8, 18, 21], "complet": 8, "demonstr": [8, 16], "text_io": [8, 10, 12, 16, 20], "json_test": 8, "my_obj": 8, "create_object": 8, "set_field": 8, "field1": [8, 15], "thenam": 8, "serial": 8, "displai": [8, 13, 16, 20, 21, 23], "2005": [8, 14], "tradit": 8, "had": [8, 10], "my_arr": 8, "json_arrai": 8, "empty_arrai": 8, "astr": 8, "hold": [8, 15], "val": [8, 12, 16], "similarli": [8, 23], "destructor": 8, "alloc": [9, 10, 11, 17, 18, 21], "dealloc": [9, 15, 17], "yourself": [9, 16], "malloc": [9, 17], "system": [9, 10, 16, 17, 18, 20, 21, 23], "proxi": 9, "replac": [9, 10, 19, 21], "extra": [9, 15, 16, 17, 21], "capabl": [9, 15, 16], "help": [9, 16, 21, 23], "moment": [9, 16], "life": 9, "prepar": [9, 21], "adb": [9, 16, 21], "put": [9, 10, 20, 21], "somewher": [9, 11, 21], "path": [9, 21, 23], "m": 9, "size_t": 9, "ptr": 9, "realloc": [9, 18], "incorpor": 9, "sai": [9, 16], "custom_rt": 9, "object_dir": 9, "obj": 9, "switch": [9, 21], "gnatg": 9, "unit": 9, "closur": 9, "zero": 9, "overhead": 9, "apart": 9, "intern": [9, 15, 16, 18, 23], "result": [9, 11, 14, 15, 16, 17, 18, 21, 23], "slow": [9, 10], "down": 9, "rerun": 9, "mark_traceback": 9, "dummi": 9, "tabl": [9, 16, 21, 22], "stack": [9, 16, 17, 21], "caller": [9, 13], "hotspot": 9, "chunk": [9, 10, 17], "group": [9, 23], "invoc": 9, "dump": 9, "sort": [9, 15], "somewhat": [9, 10, 15, 16, 20, 23], "usabl": 9, "ask": [9, 23], "block": [9, 13, 15, 16], "dangl": 9, "pointer": [9, 15, 16, 18], "lead": [9, 18], "crash": [9, 21], "side": [9, 14, 16], "frequent": 9, "buffer": [9, 10, 16, 18], "page": [9, 10, 18], "probabl": [9, 21], "occur": [9, 15], "linux": [9, 23], "0xdd": 9, "thrown": 9, "occurr": 9, "higher": 9, "less": [9, 16, 18], "random": 9, "solid": 9, "reproduc": 9, "memory_free_pattern": 9, "paramet": [9, 10, 11, 18, 19, 21], "amount": [9, 18, 21], "good": [9, 18, 23], "idea": [9, 13, 16, 18], "reduc": [9, 17], "total": [9, 16, 21], "ever": [9, 17, 18, 21], "even": [9, 10, 15, 16, 18, 21, 23], "stacktrac": 9, "show": [9, 12, 14, 16, 18, 21], "analyz": 9, "profil": [10, 14, 16], "level": [10, 16, 21, 23], "housekeep": 10, "tend": 10, "low": [10, 16, 21], "os_lib": 10, "direct": [10, 16, 21], "import": [10, 12, 16, 18], "suitabl": [10, 21], "happen": [10, 11, 21], "megabyt": 10, "reason": [10, 16, 18, 23], "temporarili": 10, "presum": 10, "lseek": 10, "order": [10, 16, 19, 21], "micro": [10, 16], "second": [10, 12, 16, 21, 23], "just": [10, 16, 18, 21, 23], "worri": 10, "speed": [10, 17], "magnitud": 10, "interest": [10, 14], "top": 10, "nice": [10, 16], "fallback": [10, 16], "transpar": [10, 16, 18, 23], "littl": [10, 18], "slower": [10, 18, 21], "adapt": 10, "due": [10, 23], "str_access": 10, "cannot": [10, 15, 16, 18, 21, 23], "attribut": [10, 12, 17, 23], "expect": [10, 16, 19, 23], "bigger": [10, 15, 18], "long": [10, 16, 18, 19, 20, 23], "Of": [10, 16, 18, 22], "fall": 10, "mapped_fil": 10, "reg": 10, "mapped_region": 10, "open_read": 10, "tmp": [10, 15, 16, 21], "file_on_disk": 10, "close": [10, 19], "larger": [10, 17, 18], "2gb": 10, "64": [10, 18], "petabyt": 10, "page_s": 10, "care": [10, 15, 16, 18, 21, 23], "round": 10, "appropri": [10, 14, 16, 19, 21, 23], "off": 10, "long_integ": 10, "get_page_s": 10, "length": [10, 18], "offset": 10, "subtl": 10, "boundari": 10, "guarante": [10, 14, 18], "realli": [10, 15, 16, 18, 23], "exactli": [10, 15, 16], "sure": [10, 18, 21], "th": 10, "open_writ": 10, "reflect": 10, "save": [10, 18], "maximum": [11, 14, 16, 18], "demand": [11, 16], "client": 11, "releas": [11, 14, 16], "request": [11, 14], "typic": [11, 15, 18, 19, 21], "creation": 11, "expens": 11, "databas": [11, 21, 22], "lazi": 11, "flexibl": [11, 16, 18, 21, 23], "dozen": 11, "retriev": [11, 13, 16, 23], "reus": [11, 21], "safe": [11, 15, 16, 18], "soon": [11, 13], "risk": [11, 16], "forget": 11, "formal": [11, 18], "describ": [11, 16, 21, 23], "final": [11, 15, 16, 19, 21], "extens": [12, 13, 16, 18, 23], "2012": 12, "95": 12, "quick": 12, "relat": [12, 23], "test_project": 12, "project_tre": 12, "file_array_access": 12, "load": 12, "path_to_project": 12, "root_project": 12, "source_fil": 12, "recurs": 12, "f": [12, 18, 23], "display_full_nam": 12, "unload": 12, "proced": 12, "project_fil": 12, "virtual_fil": [12, 23], "register_new_attribut": 12, "package_nam": 12, "els": [12, 20, 23], "is_list": 12, "rais": [12, 16, 19], "program_error": 12, "root_project_path": 12, "packages_to_check": 12, "all_pack": 12, "project_typ": 12, "string_attribut": 12, "attribute_pkg_str": 12, "string_valu": 12, "attribute_valu": 12, "indexed_attribut": 12, "indexed_valu": 12, "list_attribut": 12, "attribute_pkg_list": 12, "list_valu": 12, "string_list_access": 12, "And": [12, 17], "correspond": [12, 16, 19, 21], "item": 12, "regist": [12, 16, 21], "given": [12, 14, 15, 16, 18, 21, 23], "hierarchi": [12, 21, 23], "tell": 12, "otherwis": [12, 16, 18, 19, 21], "plain": 12, "someth": [12, 16, 23], "hello": 12, "world": [12, 18], "synchron": [13, 14], "asynchron": 13, "worker": 13, "encapsul": [13, 23], "yet": [13, 18], "unknown": 13, "background": [13, 21], "error": [13, 16, 20, 21], "certainli": [13, 16, 23], "graphic": [13, 16, 20, 21, 23], "keep": [13, 15, 16, 18, 21], "event": [13, 14], "refresh": 13, "becom": [13, 15, 16, 18, 21, 23], "action": [13, 16], "post": [13, 14, 21], "callback": [13, 16, 19], "whenev": [13, 16, 18], "finish": 13, "chain": 13, "concurr": 14, "compliant": 14, "goal": [14, 16, 17, 21], "eas": 14, "factor": 14, "behavior": [14, 16, 21], "instanti": [14, 18], "predict": 14, "permit": 14, "techniqu": 14, "simple_cyclic_task": 14, "cyclic": 14, "interv": 14, "simple_sporadic_task": 14, "sporad": 14, "enforc": [14, 16], "minimum": [14, 16], "inter": 14, "present": [14, 16], "sophist": 14, "fulfil": 14, "kind": [14, 21, 23], "queue": 14, "sporadic_server_with_callback": 14, "timed_out_sporadic_serv": 14, "particularli": 14, "former": 14, "fake": 14, "receiv": [14, 16, 21], "invok": 14, "handler": [14, 16], "within": [14, 16, 17, 18], "period": 14, "one_shot_tim": 14, "trigger": 14, "difficulti": [15, 16], "respons": [15, 16, 21], "hi": [15, 16], "behalf": 15, "approach": [15, 18, 21], "term": [15, 18], "hous": 15, "increment": [15, 18], "counter": [15, 17], "disappear": [15, 21], "decrement": 15, "reach": 15, "destroi": [15, 16], "conveni": [15, 16, 19, 23], "thing": [15, 16, 18, 21, 23], "idempot": 15, "ensur": [15, 16, 21], "mecan": 15, "child": [15, 21, 23], "my_pkg": 15, "my_typ": 15, "record": [15, 16, 21], "anyth": [15, 21], "my_type_ptr": 15, "smart_point": 15, "ref": 15, "assign": [15, 18], "goe": [15, 16], "scope": 15, "potenti": 15, "r": 15, "tricki": [15, 20], "cycl": 15, "never": [15, 16, 21], "design": [15, 16], "severli": 15, "interf": 15, "imagin": 15, "cach": [15, 23], "increas": 15, "solut": [15, 16], "weak": 15, "eventu": 15, "reset": 15, "weakref": 15, "weak_refcount": 15, "weakref_point": 15, "smart": 15, "wr": 15, "weak_ref": 15, "get_weak_ref": 15, "null_ref": 15, "simplifi": 15, "remain": [15, 16, 23], "without": [15, 16, 18, 21], "storage_error": 15, "live": 15, "construct": [15, 16], "loadabl": 16, "portabl": [16, 23], "familiar": 16, "comfort": 16, "re": 16, "too": [16, 21], "dive": 16, "lost": 16, "distribut": 16, "emb": 16, "learn": 16, "redistribut": 16, "futur": 16, "python": [16, 18], "anywai": [16, 18, 21], "suit": 16, "press": 16, "button": 16, "menu": 16, "neutral": 16, "mind": 16, "flow": 16, "e": [16, 18, 21], "g": 16, "argument": [16, 21], "quot": 16, "mandatori": [16, 19], "doubl": [16, 18], "surround": 16, "preced": 16, "backslash": [16, 23], "tripl": 16, "lose": 16, "taken": [16, 23], "function_nam": 16, "arg1": 16, "arg": [16, 21], "machin": [16, 23], "push": 16, "By": 16, "previou": [16, 17, 21], "kept": [16, 19], "visibl": 16, "view": [16, 18], "function2_nam": 16, "emul": [16, 18, 23], "orient": 16, "whose": [16, 23], "implicit": 16, "appli": [16, 18, 21], "constructor": 16, "earlier": [16, 21], "our": [16, 18], "arg2": 16, "properti": 16, "set_properti": 16, "id": 16, "echo": 16, "explicitli": 16, "clear_cach": 16, "afterward": 16, "sens": [16, 18, 19], "register_standard_class": 16, "input": 16, "mode": 16, "sy": 16, "stdin": 16, "stdout": [16, 21], "stderr": 16, "redirect": [16, 21], "set_default_consol": 16, "deriv": 16, "achiev": [16, 18], "deliv": 16, "clear": 16, "flush": 16, "noth": [16, 21], "isatti": 16, "pseudo": 16, "wrong": 16, "readlin": 16, "themselv": [16, 21], "public": 16, "convers": [16, 23], "talk": 16, "central": 16, "exchang": 16, "hash": 16, "greatest": 16, "likewis": 16, "wasn": [16, 21], "usr": 16, "doc": 16, "multistep": 16, "experi": [16, 17], "hidden": 16, "spawn": [16, 19], "plug": 16, "ins": 16, "written": [16, 21], "condit": [16, 21], "scripts_repositori": 16, "everyth": [16, 21], "kernel": 16, "around": [16, 18, 21], "scripts_repository_data": 16, "repo": 16, "scripts_repository_record": 16, "kernel_scripts_repositori": 16, "link": [16, 17, 23], "libpython": 16, "register_shell_script": 16, "register_python_script": 16, "mymodul": [16, 21], "module_nam": 16, "proper": [16, 23], "console_class": 16, "captur": 16, "least": 16, "possibli": [16, 18], "wait": 16, "virtual_console_record": 16, "throughout": 16, "feedback": [16, 20], "virtual_consol": 16, "overriden": 16, "insert_text": 16, "insert_log": 16, "insert_error": 16, "elsewher": 16, "insert_prompt": 16, "prompt": 16, "rememb": [16, 17, 18], "set_as_default_consol": 16, "enter": 16, "whole_lin": 16, "set_data_primit": 16, "get_inst": 16, "class_inst": 16, "he": [16, 22], "set_data": 16, "get_data": 16, "discard": [16, 21], "gtkconsol": 16, "lookup_scripting_languag": 16, "unus": 16, "inde": 16, "guess": [16, 20, 23], "correct": 16, "constructor_method": 16, "inst": 16, "nth_arg": 16, "my_console_record": 16, "realiz": 16, "major": 16, "scripting_languag": 16, "per": [16, 17, 18, 21], "callback_data": 16, "opaqu": 16, "set_return_valu": 16, "set_error_msg": 16, "class_typ": 16, "strongli": 16, "respect": 16, "stamp": 16, "myconsol": 16, "titl": 16, "mydata": 16, "20060619": 16, "title2": 16, "instance_properti": 16, "abl": [16, 18, 21, 23], "subprogram_record": 16, "met": [16, 21], "exact": [16, 18], "blend": 16, "smoothli": 16, "def": 16, "on_exit": 16, "set_on_exit_callback": 16, "style": [16, 20], "No": 16, "unusu": 16, "forc": [16, 20, 21], "qualifi": 16, "namespac": 16, "resolut": 16, "larg": [16, 17, 18], "redefin": 16, "behind": 16, "register_command": 16, "min_arg": 16, "max_arg": 16, "simplest": 16, "sum": 16, "arg1_c": 16, "alias": 16, "arg2_c": 16, "name_paramet": 16, "illustr": 16, "concept": 16, "proce": 16, "ie": [16, 21], "identifi": [16, 19, 21], "new_class": 16, "shown": [16, 18], "myclass": 16, "account": [16, 18], "c1": 16, "prefix1": 16, "c2": 16, "impl": 16, "elsif": 16, "get_script": 16, "don": 16, "insert": 16, "inherit": 16, "b": [16, 21], "wherea": [16, 23], "didn": 16, "fetch": 16, "mytyp": 16, "enabl": [16, 18, 20, 21], "u": 16, "mypropsr": 16, "instance_property_record": 16, "myprop": 16, "get_nam": 16, "aspect": [16, 23], "worth": [16, 23], "mostli": [16, 18], "histor": 16, "absolut": [16, 21], "inlin": 16, "cleaner": 16, "mention": [16, 18, 21], "facilit": 16, "magic": 16, "instance_list_access": 16, "meant": [16, 21, 23], "With": [16, 22], "examin": 16, "ed": 16, "editor": 16, "ed2": 16, "mytypeaccess": 16, "cmd": 16, "check_if_exist": 16, "create_new_mytyp": 16, "instance_list": 16, "no_class_inst": 16, "new_inst": 16, "myclassimpl": 16, "do_someth": 16, "gave": 16, "nicer": 16, "anywher": [16, 18], "myclassimpl_instance_0x12345": 16, "said": [16, 23], "execute_fil": 16, "lock": [16, 18], "acquir": 16, "simul": 16, "reacquir": 16, "100": [16, 18], "opcod": 16, "preemptiv": 16, "engin": 16, "initialize_threads_support": 16, "begin_allow_thread": 16, "ensure_thread_st": 16, "fast": [16, 18], "enough": [16, 18], "finer": 16, "grain": 16, "hook": 16, "doabl": 16, "tb": 16, "traceback": 16, "divid": 17, "smaller": [17, 18], "updat": 17, "storage_pool": 17, "keyword": 17, "debug_pool": 17, "leak": 17, "align": [17, 18], "accept": 17, "overcom": 17, "element": [17, 21], "reserv": 17, "overal": 17, "strings_impl": 18, "unbounded_str": 18, "attempt": [18, 21], "middl": 18, "ground": 18, "v": 18, "xstring": [18, 21], "grow": 18, "inspir": 18, "trick": 18, "improv": [18, 23], "nowadai": 18, "short": [18, 21], "avoid": [18, 21], "altogeth": 18, "unchecked_union": 18, "23": 18, "flag": 18, "signific": 18, "pad": 18, "31": 18, "half": 18, "capac": 18, "32": 18, "architectur": [18, 23], "24": 18, "endian": 18, "thank": 18, "okai": 18, "elegantli": 18, "via": [18, 20], "shift": 18, "unicod": 18, "wide_charact": 18, "wast": [18, 21], "character_typ": 18, "wide_wide_charact": 18, "scalar": 18, "dna": 18, "nucleobas": 18, "character_str": 18, "wide_str": 18, "move": 18, "fragil": 18, "cut": 18, "multi": 18, "choic": 18, "criteria": [18, 21, 22], "impact": 18, "16": 18, "15": 18, "11": 18, "sometim": [18, 23], "101": 18, "spend": [18, 21], "ll": 18, "measur": 18, "127": 18, "fit": 18, "significantli": 18, "somehow": [18, 23], "protect": 18, "practic": 18, "rare": 18, "bad": 18, "discuss": 18, "drawback": 18, "atom": 18, "prevent": 18, "pai": 18, "cost": [18, 23], "systemat": [18, 23], "plenti": 18, "past": 18, "multipli": 18, "research": 18, "compris": 18, "4096": 18, "36": 18, "54": 18, "82": 18, "122": 18, "constraint": 18, "layout": 18, "split": [18, 21, 23], "besid": 18, "empti": [18, 21], "l": [18, 21], "xstring_arrai": 18, "lf": 18, "Into": 18, "remov": [18, 23], "trail": 18, "extern": [19, 21], "delimit": 19, "overridden": [19, 21, 23], "rule": 19, "substitut": [19, 21], "curli": 19, "brace": 19, "digit": [19, 21], "12": [19, 21], "symbol": [19, 21, 23], "letter": [19, 21, 23], "underscor": 19, "ab_12": 19, "fledg": 20, "highli": 20, "modern": 20, "escap": 20, "pipe": 20, "black": 20, "white": 20, "test_color": 20, "info": [20, 21], "terminal_info": 20, "init_for_stdout": 20, "set_color": 20, "standard_output": 20, "blue": 20, "yellow": 20, "reset_al": 20, "progress": 20, "j": 20, "1_000": 20, "mod": 20, "10": 20, "delai": 20, "beginning_of_lin": 20, "clear_to_end_of_lin": 20, "logger": 21, "busi": 21, "shortcut": 21, "trace_handl": 21, "descriptor": 21, "trace_stream": 21, "ultim": 21, "investig": 21, "site": 21, "confus": 21, "silent": 21, "concentr": 21, "runtim": 21, "parse_config_fil": 21, "ada_debug_fil": 21, "gnatdebug": 21, "home": 21, "slash": [21, 23], "necessarili": [21, 23], "truncat": 21, "ones": 21, "statu": 21, "token": 21, "resp": 21, "four": 21, "module1": 21, "module2": 21, "local0": 21, "latest": 21, "none": 21, "think": 21, "local": [21, 23], "leav": 21, "pkg1": 21, "me": 21, "pkg2": 21, "matter": [21, 23], "sampl": 21, "am": 21, "assert": 21, "pre": 21, "equal": [21, 22], "fail": 21, "red": 21, "obviou": 21, "exception_occurr": 21, "backtrac": 21, "unexcept": 21, "fly": 21, "suffix": 21, "proc": 21, "speak": [21, 23], "Their": 21, "exhaust": 21, "absolute_tim": 21, "micro_tim": 21, "microsecond": 21, "millisecond": 21, "elapsed_tim": 21, "elaps": 21, "stack_trac": 21, "addr2lin": 21, "column": 21, "enclosing_ent": 21, "far": 21, "emit": 21, "breakpoint": 21, "break": 21, "split_lin": 21, "indent": 21, "finalize_trac": 21, "fold": 21, "realiti": 21, "247": 21, "2007": 21, "07": 21, "03": 21, "13": 21, "53": 21, "46": 21, "2m": 21, "loc": 21, "224": 21, "entiti": 21, "callstack": 21, "40fd9902": 21, "082fcfdd": 21, "082fe8df": 21, "trace_handle_record": 21, "pre_decor": 21, "post_decor": 21, "my_handl": 21, "trace_stream_record": 21, "media": 21, "perhap": 21, "corba": 21, "orb": 21, "charg": 21, "mystream": 21, "bar": 21, "my_stream": 21, "file_typ": 21, "msg_string": 21, "unconstrained_string_access": 21, "get_str": 21, "nor": 21, "new_stream": 21, "newli": 21, "twice": 21, "my_stream_factori": 21, "stream_factori": 21, "self": 21, "out_fil": 21, "register_stream_factori": 21, "relev": [21, 23], "register_syslog_stream": 21, "dispatch": 21, "facil": 21, "urgenc": 21, "enumer": 21, "primarili": 21, "advantag": [21, 23], "reimplement": 21, "de": 21, "pkg": 21, "explain": 21, "classic": 22, "indetermin": 22, "contact": 22, "french": [22, 23], "choos": [22, 23], "peopl": 22, "cover": 22, "xor": 22, "truth": 22, "across": 23, "forward": 23, "job": 23, "revers": 23, "expans": 23, "notion": 23, "fat": 23, "vfat": 23, "ntf": 23, "ext2": 23, "vm": 23, "famili": 23, "drive": 23, "inaccur": 23, "insensit": 23, "strive": 23, "oppos": 23, "lower": 23, "cygwin": 23, "quirk": 23, "sensit": 23, "bracket": 23, "parent": 23, "mount": 23, "nf": 23, "samba": 23, "host": 23, "children": 23, "writabl": 23, "delet": 23, "filesystem_record": 23, "get_local_filesystem": 23, "delic": 23, "asian": 23, "accent": 23, "unfortun": 23, "happili": 23, "chines": 23, "seri": 23, "fine": 23, "iso": 23, "8859": 23, "locale_to_displai": 23, "set_locale_to_display_encod": 23, "tempt": 23, "cp": 23, "stat": 23, "dir": 23, "filesystem_typ": 23, "filesystem_factori": 23, "typ": 23, "filesystem_access": 23, "unix_filesystem_record": 23, "windows_filesystem_record": 23, "remote_unix_filesystem_record": 23, "remote_windows_filesystem_record": 23, "encode_to_utf8": 23, "rsh": 23, "ssh": 23, "telnet": 23, "password": 23, "furthermor": 23, "intent": 23, "recogn": 23, "queri": 23, "filesystem_transport_record": 23, "unclear": 23, "suffici": 23, "clearer": 23, "slight": 23}, "objects": {}, "objtypes": {}, "objnames": {}, "titleterms": {"boyer": 0, "moor": 0, "search": 0, "string": [0, 18], "build": 1, "gnatcol": [1, 6], "configur": [1, 2, 18, 21], "environ": 1, "instal": 1, "config": 2, "pars": [2, 3], "file": [2, 10, 12, 23], "email": 3, "process": 3, "messag": 3, "format": [3, 4], "mailbox": 3, "creat": [3, 16], "paragraph": 4, "fill": 4, "text": [4, 19], "geometri": 5, "primit": 5, "geometr": 5, "oper": 5, "core": 6, "compon": [6, 7], "indic": 6, "tabl": 6, "introduct": 7, "gnat": 7, "collect": 7, "bug": 7, "report": 7, "json": 8, "handl": [8, 21], "data": 8, "api": [8, 16, 18], "overview": 8, "exampl": 8, "memori": [9, 17], "monitor": 9, "usag": 9, "mmap": 10, "read": [10, 12], "write": [10, 18], "pool": [11, 17], "control": [11, 17, 20], "access": 11, "resourc": 11, "project": 12, "manipul": [12, 23], "gpr": 12, "defin": [12, 21], "user": 12, "packag": 12, "them": 12, "promis": 13, "defer": 13, "work": 13, "ravenscar": 14, "pattern": 14, "multitask": 14, "task": [14, 18], "server": 14, "timer": 14, "refcount": 15, "refer": 15, "count": 15, "script": 16, "embed": 16, "languag": 16, "support": 16, "The": 16, "shell": 16, "class": 16, "export": 16, "all": 16, "initi": 16, "modul": [16, 21], "repositori": 16, "load": 16, "standard": 16, "interact": 16, "consol": [16, 20], "method": 16, "diagram": 16, "function": 16, "automat": 16, "paramet": 16, "type": [16, 18, 21], "name": [16, 23], "reus": 16, "instanc": 16, "execut": 16, "startup": 16, "multithread": 16, "applic": 16, "debug": 16, "storag": 17, "manag": 17, "high": 18, "perform": 18, "small": 18, "optim": 18, "charact": 18, "size": 18, "safeti": 18, "copi": 18, "growth": 18, "strategi": 18, "substr": 18, "templat": 19, "gener": 19, "termin": 20, "color": 20, "cursor": 20, "trace": 21, "log": 21, "inform": 21, "us": 21, "unexpect": 21, "except": 21, "check": 21, "whether": 21, "i": 21, "activ": 21, "decor": 21, "custom": 21, "stream": 21, "syslog": 21, "dynam": 21, "disabl": 21, "featur": 21, "triboolean": 22, "three": 22, "state": 22, "logic": 22, "vf": 23, "filesystem": 23, "abstract": 23, "encod": 23, "remot": 23, "factori": 23, "transport": 23, "layer": 23, "virtual": 23}, "envversion": {"sphinx.domains.c": 3, "sphinx.domains.changeset": 1, "sphinx.domains.citation": 1, "sphinx.domains.cpp": 9, "sphinx.domains.index": 1, "sphinx.domains.javascript": 3, "sphinx.domains.math": 2, "sphinx.domains.python": 4, "sphinx.domains.rst": 2, "sphinx.domains.std": 2, "sphinx": 60}, "alltitles": {"Boyer-Moore: Searching strings": [[0, "boyer-moore-searching-strings"]], "Building GNATColl": [[1, "building-gnatcoll"], [1, "id3"]], "Configuring the build environment": [[1, "configuring-the-build-environment"]], "Installing GNATColl": [[1, "installing-gnatcoll"]], "Config: Parsing configuration files": [[2, "config-parsing-configuration-files"]], "Email: Processing email messages": [[3, "email-processing-email-messages"]], "Message formats": [[3, "message-formats"]], "Parsing messages": [[3, "parsing-messages"]], "Parsing mailboxes": [[3, "parsing-mailboxes"]], "Creating messages": [[3, "creating-messages"]], "Paragraph filling: formatting text": [[4, "paragraph-filling-formatting-text"]], "Geometry: primitive geometric operations": [[5, "geometry-primitive-geometric-operations"]], "GNATColl Core Components": [[6, "gnatcoll-core-components"]], "Indices and tables": [[6, "indices-and-tables"]], "Introduction to the GNAT Component Collection": [[7, "introduction-to-the-gnat-component-collection"]], "Bug reports": [[7, "bug-reports"]], "JSON: handling JSON data": [[8, "json-handling-json-data"]], "API overview": [[8, "api-overview"]], "Examples": [[8, "examples"]], "Memory: Monitoring memory usage": [[9, "memory-monitoring-memory-usage"]], "Mmap: Reading and Writing Files": [[10, "mmap-reading-and-writing-files"]], "Pools: Controlling access to resources": [[11, "pools-controlling-access-to-resources"]], "Projects: manipulating gpr files": [[12, "projects-manipulating-gpr-files"]], "Defining a project with user-defined packages and reading them": [[12, "defining-a-project-with-user-defined-packages-and-reading-them"]], "Promises: deferring work": [[13, "promises-deferring-work"]], "Ravenscar: patterns for multitasking": [[14, "ravenscar-patterns-for-multitasking"]], "Tasks": [[14, "tasks"]], "Servers": [[14, "servers"]], "Timers": [[14, "timers"]], "Refcount: Reference counting": [[15, "refcount-reference-counting"]], "Scripts: Embedding script languages": [[16, "scripts-embedding-script-languages"]], "Supported languages": [[16, "supported-languages"]], "The Shell language": [[16, "the-shell-language"]], "Classes exported to all languages": [[16, "classes-exported-to-all-languages"]], "Scripts API": [[16, "scripts-api"]], "Initializing the scripting module": [[16, "initializing-the-scripting-module"]], "Create the scripts repository": [[16, "create-the-scripts-repository"]], "Loading the scripting language": [[16, "loading-the-scripting-language"]], "Exporting standard classes": [[16, "exporting-standard-classes"]], "Creating interactive consoles": [[16, "creating-interactive-consoles"]], "Exporting classes and methods": [[16, "exporting-classes-and-methods"]], "Classes diagram": [[16, "classes-diagram"]], "Exporting functions": [[16, "exporting-functions"]], "Automatic parameters types": [[16, "automatic-parameters-types"]], "Support for named parameters": [[16, "support-for-named-parameters"]], "Exporting classes": [[16, "exporting-classes"]], "Reusing class instances": [[16, "reusing-class-instances"]], "Executing startup scripts": [[16, "executing-startup-scripts"]], "Multithreading applications and scripts": [[16, "multithreading-applications-and-scripts"]], "Debugging scripts": [[16, "id16"]], "Storage Pools: controlling memory management": [[17, "storage-pools-controlling-memory-management"]], "Strings: high-performance strings": [[18, "strings-high-performance-strings"]], "Small string optimization": [[18, "small-string-optimization"]], "Character types": [[18, "character-types"]], "Configuring the size of small strings": [[18, "configuring-the-size-of-small-strings"]], "Task safety": [[18, "task-safety"]], "Copy on write": [[18, "copy-on-write"]], "Growth strategy": [[18, "growth-strategy"]], "Substrings": [[18, "substrings"]], "API": [[18, "api"]], "Templates: generating text": [[19, "templates-generating-text"]], "Terminal: controlling the console": [[20, "terminal-controlling-the-console"]], "Colors": [[20, "colors"]], "Cursors": [[20, "cursors"]], "Traces: Logging information": [[21, "traces-logging-information"]], "Configuring traces": [[21, "configuring-traces"]], "Using the traces module": [[21, "using-the-traces-module"]], "Logging unexpected exceptions": [[21, "logging-unexpected-exceptions"]], "Checking whether the handle is active": [[21, "checking-whether-the-handle-is-active"]], "Log decorators": [[21, "log-decorators"]], "Defining custom stream types": [[21, "defining-custom-stream-types"]], "Logging to syslog": [[21, "logging-to-syslog"]], "Dynamically disabling features": [[21, "dynamically-disabling-features"]], "Tribooleans: Three state logic": [[22, "tribooleans-three-state-logic"]], "VFS: Manipulating Files": [[23, "vfs-manipulating-files"]], "Filesystems abstraction": [[23, "filesystems-abstraction"]], "file names encoding": [[23, "file-names-encoding"]], "Remote filesystems": [[23, "remote-filesystems"]], "Filesystem factory": [[23, "filesystem-factory"]], "Transport layer": [[23, "transport-layer"]], "Virtual files": [[23, "virtual-files"]]}, "indexentries": {"boyer-moore": [[0, "index-0"]], "search": [[0, "index-1"]], "gnatcoll.email": [[3, "index-5"]], "gnatcoll.email.mailboxes": [[3, "index-6"]], "gnatcoll.email.parser": [[3, "index-4"]], "gnatcoll.email.utils": [[3, "index-1"]], "mime": [[3, "index-2"]], "email": [[3, "index-0"]], "encoding": [[3, "index-3"]], "knuth": [[4, "index-2"]], "filling": [[4, "index-1"]], "paragraph filling": [[4, "index-0"]], "json": [[8, "index-0"]], "mmap": [[10, "index-0"]], "ravenscar": [[14, "index-0"]], "reference": [[15, "index-1"]], "reference counting": [[15, "index-0"]], "weak": [[15, "index-1"]], "class callback_data": [[16, "index-26"]], "class class_instance": [[16, "index-28"]], "class console": [[16, "index-5"]], "class instance_property": [[16, "index-29"]], "class scripting_language": [[16, "index-25"]], "class scripts_repository": [[16, "index-24"]], "class subprogram_record": [[16, "index-30"]], "console.clear": [[16, "index-7"]], "console.flush": [[16, "index-8"]], "console.isatty": [[16, "index-9"]], "console.read": [[16, "index-10"]], "console.readline": [[16, "index-11"]], "console.write": [[16, "index-6"]], "function clear_cache": [[16, "index-4"]], "function echo": [[16, "index-3"]], "function load": [[16, "index-2"]], "procedure register_python_scripting": [[16, "index-13"]], "procedure register_shell_scripting": [[16, "index-12"]], "procedure register_standard_classes": [[16, "index-14"]], "record class_type": [[16, "index-27"]], "register_command": [[16, "index-31"]], "virtual_console.get_instance": [[16, "index-22"]], "virtual_console.insert_error": [[16, "index-17"]], "virtual_console.insert_log": [[16, "index-16"]], "virtual_console.insert_prompt": [[16, "index-18"]], "virtual_console.insert_text": [[16, "index-15"]], "virtual_console.read": [[16, "index-20"]], "virtual_console.set_as_default_console": [[16, "index-19"]], "virtual_console.set_data_primitive": [[16, "index-21"]], "class diagram": [[16, "index-23"]], "script module": [[16, "index-23"]], "test driver": [[16, "index-0"]], "testing your application": [[16, "index-1"]], "templates": [[19, "index-0"]], ".gnatdebug": [[21, "index-1"]], "ada_debug_file": [[21, "index-0"]], "logger": [[21, "index-3"]], "trace_handle": [[21, "index-2"]], "decorator": [[21, "index-4"]], "gnat.traces.syslog": [[21, "index-6"]], "log": [[21, "index-4"]], "syslog": [[21, "index-5"]]}})